function HidePlates:updateModifier(newValue)
	self.config.global.modifier = newValue
	config.global["modifier"] = newValue
	for _, unitId in pairs(self.namePlates) do
        self:updateVisibility(unitId)
	end
end

function HidePlates:updateToggle(newValue)
	self.config.global.toggle = newValue
	config.global["toggle"] = newValue
end

function HidePlates:updateForceHide(newValue)
	self.config.global.forceHide = newValue
	config.global["forceHide"] = newValue
end

function HidePlates:updateInterruptShow(newValue)
	if newValue then
		HidePlates.config.functions["interrupt"] = updateVisibilityInterrupts
	else
		HidePlates.config.functions["interrupt"] = nil
	end
	config.interrupt["enable"] = newValue
	for _, unitId in pairs(self.namePlates) do
        self:updateVisibility(unitId)
	end
end

function HidePlates:updateNotInterruptible(newValue)
	self.config.interrupt.notInterruptible = newValue
	config.interrupt["notInterruptible"] = newValue
	for _, unitId in pairs(self.namePlates) do
        self:updateVisibility(unitId)
	end
end

function HidePlates:updateAggroShow(newValue)
	if newValue then
		HidePlates.config.functions["aggro"] = updateVisibilityAggro
	else
		HidePlates.config.functions["aggro"] = nil
	end
	config.aggro["enable"] = newValue
	for _, unitId in pairs(self.namePlates) do
        self:updateVisibility(unitId)
	end
end

function HidePlates:initializeConfig()
	self:updateModifier(config.global["modifier"])
	self:updateToggle(config.global["toggle"])
	self:updateForceHide(config.global["forceHide"])
	self:updateInterruptShow(config.interrupt["enable"])
	self:updateNotInterruptible(config.interrupt["notInterruptible"])
	self:updateAggroShow(config.aggro["enable"])
end