HidePlates = LibStub("AceAddon-3.0"):NewAddon("HidePlates", "AceConsole-3.0", "AceEvent-3.0" )
HidePlates.namePlates = {}
HidePlates.showAll = true
HidePlates.modifiers = {}
HidePlates.toggle = false
HidePlates.config = {}
HidePlates.config.initializer = {
	navigation = function(self, level)
		local info = UIDropDownMenu_CreateInfo()
		info.func = self.SetValue
		for i = 0,tablelength(HidePlates.frames.options.submenus) - 1 do
			info.text, info.arg1, info.checked = HidePlates.frames.options.submenus[i], i, HidePlates.frames.options.currentSubmenu == i
			UIDropDownMenu_AddButton(info, level)
		end
	end,
	global = {
		modifier = function(self, level)
			local info = UIDropDownMenu_CreateInfo()
			info.func = self.SetValue
			for i = 0,tablelength(HidePlates.modifiers) - 1 do
				info.text, info.arg1, info.checked = HidePlates.modifiers[i], i, HidePlates.config.global.modifier == i
				UIDropDownMenu_AddButton(info, level)
			end
		end,
		toggle = function(self, level)
			local info = UIDropDownMenu_CreateInfo()
			info.func = self.SetValue
			info.text, info.arg1, info.checked = "true", true, HidePlates.config.global.toggle
			UIDropDownMenu_AddButton(info, level)
			info.text, info.arg1, info.checked = "false", false, not HidePlates.config.global.toggle
			UIDropDownMenu_AddButton(info, level)
		end,
		forceHide = function(self, level)
			local info = UIDropDownMenu_CreateInfo()
			info.func = self.SetValue
			info.text, info.arg1, info.checked = "true", true, HidePlates.config.global.forceHide
			UIDropDownMenu_AddButton(info, level)
			info.text, info.arg1, info.checked = "false", false, not HidePlates.config.global.forceHide
			UIDropDownMenu_AddButton(info, level)
		end
	},
	interrupt = {
		enable = function(self, level)
			local info = UIDropDownMenu_CreateInfo()
			info.func = self.SetValue
			info.text, info.arg1, info.checked = "true", true, HidePlates.config.functions["interrupt"] ~= nil
			UIDropDownMenu_AddButton(info, level)
			info.text, info.arg1, info.checked = "false", false, HidePlates.config.functions["interrupt"] == nil
			UIDropDownMenu_AddButton(info, level)
		end,
		notInterruptible = function(self, level)
			local info = UIDropDownMenu_CreateInfo()
			info.func = self.SetValue
			info.text, info.arg1, info.checked = "true", true, HidePlates.config.interrupt.notInterruptible
			UIDropDownMenu_AddButton(info, level)
			info.text, info.arg1, info.checked = "false", false, not HidePlates.config.interrupt.notInterruptible
			UIDropDownMenu_AddButton(info, level)
		end
	},
	aggro = {
		enable = function(self, level)
			local info = UIDropDownMenu_CreateInfo()
			info.func = self.SetValue
			info.text, info.arg1, info.checked = "true", true, HidePlates.config.functions["aggro"] ~= nil
			UIDropDownMenu_AddButton(info, level)
			info.text, info.arg1, info.checked = "false", false, HidePlates.config.functions["aggro"] == nil
			UIDropDownMenu_AddButton(info, level)
		end,
	}
}
HidePlates.config.global = {}
HidePlates.config.interrupt = {}
HidePlates.config.functions = {}
HidePlates.frames = {}
HidePlates.frames.options = {}
HidePlates.dropDown = {}
HidePlates.dropDown.global = {}
HidePlates.dropDown.interrupt = {}
HidePlates.dropDown.aggro = {}
HidePlates.updater = CreateFrame("Frame", "HidePlatesUpdater")

local LDB = LibStub( "LibDataBroker-1.1")
local LDBIcon = LibStub("LibDBIcon-1.0")

function HidePlates:OnInitialize()
	self:checkConfig()
	self:initializeModifiers()
	self:initializeConfig()
	self:setUpInterface()
	self:initializeAllEvents()
	self:initializeSlashCommands()

	hP = LibStub("LibDataBroker-1.1"):NewDataObject("HidePlates", {
		type = "launcher",
		label = "HidePlates",
		icon = 	"interface/icons/ability_mage_invisibility",
		OnClick = function(_, button) if button == "LeftButton" then if HidePlates.frames["options"]:IsShown() then HidePlates.frames["options"]:Hide() else HidePlates.frames["options"]:Show() end end end,
		OnTooltipShow = function( tt ) tt:AddLine( "|cFFFFFFFFHidePlates|r" ) tt:AddLine( "|cFFFFFFFFLeft-click to open/close options.|r" ) end,
	})
	LDBIcon:Register("HidePlates", hP, nil)
end

function HidePlates:OnEnable()
end

function HidePlates:OnDisable()
	return
end

function HidePlates:checkConfig()
	if config == nil then
		config = {}
		config.global = {}
		config.global["modifier"] = 0
		config.global["toggle"] = true
		config.global["forceHide"] = true
		config.interrupt = {}
		config.interrupt["enable"] = true
		config.interrupt["notInterruptible"] = true
		config.aggro = {}
		config.aggro["enable"] = true
	else
		if not config.global then
			config.global = {}
		end
		if not config.interrupt then
			config.interrupt = {}
		end
		if not config.aggro then
			config.aggro = {}
		end
		if config.global["modifier"] == nil then
			config.global["modifier"] = 0
		end
		if config.global["toggle"] == nil then
			config.global["toggle"] = true
		end
		if config.global["forceHide"] == nil then
			config.global["forceHide"] = true
		end
		if config.interrupt["enable"] == nil then
			config.interrupt["enable"] = true
		end
		if config.interrupt["notInterruptible"] == nil then
			config.interrupt["notInterruptible"] = true
		end
		if config.aggro["enable"] == nil then
			config.aggro["enable"] = true
		end
	end
end

function HidePlates:initializeModifiers()
	self.modifiers[0] = "LALT"
	self.modifiers[1] = "LCTRL"
	self.modifiers[2] = "LSHIFT"
	self.modifiers[3] = "RALT"
	self.modifiers[4] = "RCTRL"
	self.modifiers[5] = "RSHIFT"
end

function HidePlates:initializeEvent(event, func)
	local f = CreateFrame("Frame")
	f:RegisterEvent(event)
	f:SetScript("OnEvent", func)
end

function HidePlates:initializeAllEvents()
	self.updater:SetScript("OnUpdate", forceUpdate)

	self:initializeEvent("MODIFIER_STATE_CHANGED", modifierChanged)

	self:initializeEvent("NAME_PLATE_UNIT_ADDED", unitAdded)

	self:initializeEvent("NAME_PLATE_UNIT_REMOVED", unitRemoved)

	self:initializeEvent("UNIT_SPELLCAST_START", spellCast)
	self:initializeEvent("UNIT_SPELLCAST_STOP", spellCast)
	self:initializeEvent("UNIT_SPELLCAST_CHANNEL_START", spellCast)
	self:initializeEvent("UNIT_SPELLCAST_CHANNEL_STOP", spellCast)

	self:initializeEvent("UNIT_THREAT_LIST_UPDATE", threatChanged)
end