local self = HidePlates

function forceUpdate()
	if self.config.global.forceHide then
        for _, unitId in pairs(self.namePlates) do
            self:updateVisibility(unitId)
        end
    end
end

function modifierChanged(_, _, key, state)
    if key == self.modifiers[self.config.global.modifier] then
        if self.config.global.toggle then
            if state ==1 then
                self.toggle = not self.toggle
                if self.toggle then
                    self:showOnlySpecificNamePlates()
                else
                    self:showAllNamePlates()
                end
            end
        else
            if state == 1 then
                self:showOnlySpecificNamePlates()
            else
                self:showAllNamePlates()
            end
        end
    end
end

function unitAdded(_, _, unitId)
	self:updateVisibility(unitId)
    for _, otherUnitId in pairs(self.namePlates) do
        if unitId == otherUnitId then return end
    end
    table.insert(self.namePlates, unitId)
end

function unitRemoved(_, _, unitId)
	for index, otherUnitId in pairs(self.namePlates) do
        if unitId == otherUnitId then
            table.remove(self.namePlates,index) 
            return
        end
    end
end

function spellCast(_, _, unitId)
	self:updateVisibility(unitId)
end

function threatChanged(_, _, unitId)
	self:updateVisibility(unitId)
end