function HidePlates:getUnitFrame(nameplate)
	if nameplate.unitFrame then
		return nameplate.unitFrame
	elseif nameplate.extented then
		return nameplate.extended
	elseif nameplate.TPFrame then
		return nameplate.TPFrame
	elseif nameplate.kui then
		return nameplate.kui.HealthBar
	else
		return nameplate.UnitFrame
	end
end

function HidePlates:showOnlySpecificNamePlates()
    self.showAll = false
    for _, unitId in pairs(self.namePlates) do
        self:updateVisibility(unitId)
	end
end

function HidePlates:showAllNamePlates()
    self.showAll = true
    for _, unitId in pairs(self.namePlates) do
        self:updateVisibility(unitId)  
    end
end

function HidePlates:updateVisibility(unitId)
	local unitPlate = C_NamePlate.GetNamePlateForUnit(unitId)
    if unitPlate == nil then
        return
    end
    
    local unitFrame = self:getUnitFrame(unitPlate)
    
    if self.showAll then   
        unitFrame:Show()
        return
    end

	for _, func in pairs(self.config.functions) do
		if func(unitId, unitFrame) then return end
	end
	
    unitFrame:Hide()
end

function updateVisibilityInterrupts(unitId, unitFrame)
    local _, _, _, _, _, _, _, notInterruptible, spellId =  UnitCastingInfo(unitId)
    
    if not spellId then
        _, _, _, _, _, _, notInterruptible, spellId =  UnitChannelInfo(unitId)
    end
    
    if spellId then
        if HidePlates.config.interrupt.notInterruptible or not notInterruptible then
            unitFrame:Show()
            return true
        end    
    end
    
	return false
end

function updateVisibilityAggro(unitId, unitFrame)
    local threatStatus = UnitThreatSituation("player", unitId)
    
    if not threatStatus or threatStatus == 0 or threatStatus == 1 then
		unitFrame:Show()
		return true
    end
    
	return false
end